// Code generated by go-swagger; DO NOT EDIT.

package virtual_machines

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	"github.com/go-openapi/runtime/middleware"
)

// VMGetHandlerFunc turns a function with the right signature into a vm get handler
type VMGetHandlerFunc func(VMGetParams) middleware.Responder

// Handle executing the request and returning a response
func (fn VMGetHandlerFunc) Handle(params VMGetParams) middleware.Responder {
	return fn(params)
}

// VMGetHandler interface for that can handle valid vm get params
type VMGetHandler interface {
	Handle(VMGetParams) middleware.Responder
}

// NewVMGet creates a new http.Handler for the vm get operation
func NewVMGet(ctx *middleware.Context, handler VMGetHandler) *VMGet {
	return &VMGet{Context: ctx, Handler: handler}
}

/*VMGet swagger:route GET /api/vms/{id} Virtual machines vmGet

Get virtual machine

*/
type VMGet struct {
	Context *middleware.Context
	Handler VMGetHandler
}

func (o *VMGet) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		r = rCtx
	}
	var Params = NewVMGetParams()

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params) // actually handle the request

	o.Context.Respond(rw, r, route.Produces, route, res)

}
